"use strict";
this.name               = "hudselector";
this.author               = "Norby";
this.copyright            = "2014 Norby";
this.description         = "Change your HUD during flight between the supported ones.";
this.version            = "1.0";
this.licence     = "CC BY-NC-SA 4.0";


this.$HUDSelectorHUDs = [["Default HUD","hud"], //name and .plist of supported HUDs
//			["Your HUD","yourhud"], //insert your (not scripted) HUD here
			["Original HUD","hud-hiddenMFDs"],//copy of oolite hud.plist but up to 10 MFDs
//			["Small HUD","hud-small"], //removed due to only one MFD defined so will close others
			["Small HUD","hud-small-hiddenMFDs"] //copy of smallhud.plist but up to 10 MFDs
			];

//internal properties, should not touch
this.$HUDSelectorEqSel = 0; //number of the selected HUD
this.$HUDSelectorTimer = null; //store a 0.1s delay timer for other startUps

//equipment events
this.activated = function() {
	var w = worldScripts.hudselector;
	w.$HUDSelectorEqSel++; //select next HUD
	if( w.$HUDSelectorEqSel >= w.$HUDSelectorHUDs.length ) w.$HUDSelectorEqSel = 0;
	player.consoleMessage( w.$HUDSelectorHUDs[w.$HUDSelectorEqSel][0]+" selected", 10 );
	w.$HUDSelectorSetHUD(w);
}

this.mode = function() {
	
}

//worldscript events
this.startUp = function() {
	this.$HUDSelectorEqSel = 0; //number of the selected HUD
	this.$HUDSelectorTimer = new Timer(this, this.$HUDSelectorRestoreHUD.bind(this), 0.1, 0); //0.1s delay for other startUps
}

this.playerBoughtEquipment = function(equipmentKey) {
	if( equipmentKey == "EQ_HUDSELECTOR_REMOVE" ) {
		var eq = equipmentKey.substr( 0, equipmentKey.length-7 );//the real eq
		player.ship.removeEquipment( eq ); //remove it
		player.ship.removeEquipment( equipmentKey ); //remove the "bought" remove eq
	}
}

this.playerWillSaveGame = function(message) {
       missionVariables.$HUDSelectorHUD = player.ship.hud;
}

this.shipWillLaunchFromStation = function() {
}

//HUDSelector methods
this.$HUDSelectorAddHUD = function(hudname, hudplist) {
	worldScripts.hudselector.$HUDSelectorHUDs.push([hudname, hudplist]);
}

this.$HUDSelectorRestoreHUD = function() { //call after all startUp finished where other worldScripts can add HUDs
	var w = worldScripts.hudselector;
	var hud = missionVariables.$HUDSelectorHUD; //restore saved HUD
	if( hud && hud.length > 0 ) {
		for( var i = 0; i < w.$HUDSelectorHUDs.length; i++ ) {
			if( w.$HUDSelectorHUDs[i][1] == hud ) {
				w.$HUDSelectorEqSel = i;
				w.$HUDSelectorSetHUD(w);
			}
		}
	}
}

this.$HUDSelectorSetHUD = function(w) {
	var p = w.$HUDSelectorHUDs[w.$HUDSelectorEqSel][1];
	for( var i = 0; i < w.$HUDSelectorHUDs.length; i++ ) { //call callback functions
		var off = true; //deactivate all HUDs
		if( i == w.$HUDSelectorEqSel ) off = false; //activate the selected one
		var wh = worldScripts[w.$HUDSelectorHUDs[i][1]];
		if( wh && wh.$HUDSelectorCallBack ) wh.$HUDSelectorCallBack( off );
		//if( wh ) wh += wh.$HUDSelectorCallBack; //debug
		//log("hudselector",i+". "+p+" "+wh); //debug
	}
	player.ship.hud =  p+".plist"; //set the selected HUD
}
